<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Grid &mdash; cflowpy Jule 2023 documentation</title>
      <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="_static/jquery.js"></script>
        <script src="_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
        <script src="_static/doctools.js"></script>
        <script src="_static/sphinx_highlight.js"></script>
    <script src="_static/js/theme.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Physical Problem" href="physical_problem.html" />
    <link rel="prev" title="Tutorial" href="tutorial.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="index.html" class="icon icon-home">
            cflowpy
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">cflowpy:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="tutorial.html">Tutorial</a></li>
<li class="toctree-l1 current"><a class="current reference internal" href="#">Grid</a><ul>
<li class="toctree-l2"><a class="reference internal" href="#constructor">Constructor</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.__init__"><code class="docutils literal notranslate"><span class="pre">Grid.__init__()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#get-routines">Get routines</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.get_x"><code class="docutils literal notranslate"><span class="pre">Grid.get_x()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.get_y"><code class="docutils literal notranslate"><span class="pre">Grid.get_y()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.get_dx"><code class="docutils literal notranslate"><span class="pre">Grid.get_dx()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.get_dy"><code class="docutils literal notranslate"><span class="pre">Grid.get_dy()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.get_u"><code class="docutils literal notranslate"><span class="pre">Grid.get_u()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.get_v"><code class="docutils literal notranslate"><span class="pre">Grid.get_v()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.get_p"><code class="docutils literal notranslate"><span class="pre">Grid.get_p()</span></code></a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="#calculation-routines">Calculation routines</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.central_fd"><code class="docutils literal notranslate"><span class="pre">Grid.central_fd()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.central_fd_deg1"><code class="docutils literal notranslate"><span class="pre">Grid.central_fd_deg1()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.central_fd_deg2"><code class="docutils literal notranslate"><span class="pre">Grid.central_fd_deg2()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.laplace"><code class="docutils literal notranslate"><span class="pre">Grid.laplace()</span></code></a></li>
<li class="toctree-l3"><a class="reference internal" href="#src.Grid.jacobi"><code class="docutils literal notranslate"><span class="pre">Grid.jacobi()</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="physical_problem.html">Physical Problem</a></li>
<li class="toctree-l1"><a class="reference internal" href="integrator.html">Integrator</a></li>
<li class="toctree-l1"><a class="reference internal" href="system.html">Solving the incompressible Navier-Stokes Equation</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">cflowpy</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="index.html" class="icon icon-home" aria-label="Home"></a></li>
      <li class="breadcrumb-item active">Grid</li>
      <li class="wy-breadcrumbs-aside">
            <a href="_sources/grid.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="grid">
<h1>Grid<a class="headerlink" href="#grid" title="Permalink to this heading"></a></h1>
<div class="line-block">
<div class="line">In the following, one can find the purpose of the class <code class="docutils literal notranslate"><span class="pre">Grid</span></code>
and it’s attributes.</div>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<div class="line-block">
<div class="line">The class <code class="docutils literal notranslate"><span class="pre">Grid</span></code> is used in <code class="docutils literal notranslate"><span class="pre">System</span></code>.</div>
<div class="line">However, it is not needed to create an instance of <code class="docutils literal notranslate"><span class="pre">Grid</span></code>
by the user itself, this is done in <code class="docutils literal notranslate"><span class="pre">System</span></code> itself.</div>
</div>
</div>
<dl class="py class">
<dt class="sig sig-object py">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">src.</span></span><span class="sig-name descname"><span class="pre">Grid</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xBegin</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">xEnd</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nCellsX</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yBegin</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yEnd</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nCellsY</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em><span class="sig-paren">)</span></dt>
<dd><p>This Class is used to generate a grid in rectangular coordinates.</p>
<p>This Grid can be used to solve the incompressible Navier-Stokes
momentum equation with Chorin’s projection method.</p>
<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">x</span></span></dt>
<dd><p>x-coordinates of the grid</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">y</span></span></dt>
<dd><p>y-coordinates of the grid</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">dx</span></span></dt>
<dd><p>Size between two points in x-direction</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">dy</span></span></dt>
<dd><p>Size between two points in y-direction</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">u</span></span></dt>
<dd><p>Velocity in x-direction (instantiated with zero)</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">v</span></span></dt>
<dd><p>Velocity in y-direction (instantiated with zero)</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py">
<span class="sig-name descname"><span class="pre">p</span></span></dt>
<dd><p>Pressure (instantiated with zero)</p>
<dl class="field-list simple">
<dt class="field-odd">Type<span class="colon">:</span></dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<section id="constructor">
<h2>Constructor<a class="headerlink" href="#constructor" title="Permalink to this heading"></a></h2>
<p>The Constructor of <code class="docutils literal notranslate"><span class="pre">Grid</span></code> works with the following:</p>
<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.__init__">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">xBegin</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">xEnd</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nCellsX</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yBegin</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">yEnd</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">nCellsY</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.__init__" title="Permalink to this definition"></a></dt>
<dd><p>Constructor</p>
<p>Generates a grid in rectangular coordinates with a desired
size in x- and y-direction.
Instantiates velocities in x- and y-direction and a pressure
with zeros.
Computes the difference between grid-cells in x- and y-direction</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>xBegin</strong> (<em>float</em>) – Left side of the domain</p></li>
<li><p><strong>xEnd</strong> (<em>float</em>) – Right side of the domain</p></li>
<li><p><strong>nCellsX</strong> (<em>int</em>) – Number of Cells in x-direction</p></li>
<li><p><strong>yBegin</strong> (<em>float</em>) – Lower side of the domain</p></li>
<li><p><strong>yEnd</strong> (<em>float</em>) – Upper side of the domain</p></li>
<li><p><strong>nCellsY</strong> (<em>int</em>) – Number of Cells in y-direction</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>ValueError</strong> – If the end of the domain in x-direction is lower then the
    begin of the domain in x-direction</p></li>
<li><p><strong>ValueError</strong> – If the end of the domain in y-direction is lower then the
    begin of the domain in y-direction</p></li>
<li><p><strong>ValueError</strong> – If the number of cells in x or y-direction is smaller as one.</p></li>
<li><p><strong>TypeError</strong> – If the number of cells in x or y-direction is no integer</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</section>
<section id="get-routines">
<h2>Get routines<a class="headerlink" href="#get-routines" title="Permalink to this heading"></a></h2>
<p><code class="docutils literal notranslate"><span class="pre">Grid</span></code> has the following routines to get attributes of the class itself.</p>
<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.get_x">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">get_x</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.get_x" title="Permalink to this definition"></a></dt>
<dd><p>Get access to the x-coordinates of the grid</p>
<dl class="field-list simple">
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>x-coordinates of the grid</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.array</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.get_y">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">get_y</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.get_y" title="Permalink to this definition"></a></dt>
<dd><p>Get access to the y-coordinates of the grid</p>
<dl class="field-list simple">
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>y-coordinates of the grid</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.array</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.get_dx">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">get_dx</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.get_dx" title="Permalink to this definition"></a></dt>
<dd><dl class="simple">
<dt>Get access to the distance between</dt><dd><p>grid points in x-direction</p>
</dd>
</dl>
<dl class="field-list simple">
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>distance between grid points in x-direction</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.get_dy">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">get_dy</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.get_dy" title="Permalink to this definition"></a></dt>
<dd><dl class="simple">
<dt>Get access to the distance between</dt><dd><p>grid points in y-direction</p>
</dd>
</dl>
<dl class="field-list simple">
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>distance between grid points in y-direction</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.get_u">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">get_u</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.get_u" title="Permalink to this definition"></a></dt>
<dd><p>Get access to the velocity in x-direction</p>
<dl class="field-list simple">
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>velocity in x-direction</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.array</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.get_v">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">get_v</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.get_v" title="Permalink to this definition"></a></dt>
<dd><p>Get access to the velocity in y-direction</p>
<dl class="field-list simple">
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>velocity in y-direction</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.array</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.get_p">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">get_p</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.get_p" title="Permalink to this definition"></a></dt>
<dd><p>Get access to the pressure of the grid</p>
<dl class="field-list simple">
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>pressure</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.array</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="calculation-routines">
<h2>Calculation routines<a class="headerlink" href="#calculation-routines" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">Furthermore <code class="docutils literal notranslate"><span class="pre">Grid</span></code> has several routines to do calculations
with finite differences.</div>
<div class="line">It is possible to compute the central finite differences of
order 1 and 2 on coordinates of the grid.</div>
<div class="line">Additionally, it is possible to get the Laplace Operator.</div>
<div class="line">A Poisson Equation can be solved with the Jacobi method
on this grid, too.</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.central_fd">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">central_fd</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">val</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">i_para_dim</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">order</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.central_fd" title="Permalink to this definition"></a></dt>
<dd><p>Computes central finite-differences.</p>
<p>Used to compute central finite-differences of a 2d-Matrix.
Zeros will be returned at the boundary.</p>
<p>It is highly recommended to always use this function instead of
“central_fd_deg1” or “central_fd_deg2” since in those two functions
there is no checking of the input.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>val</strong> (<em>np.array</em>) – Input array to compute the central finite-differences on</p></li>
<li><p><strong>i_para_dim</strong> (<em>int</em>) – parametric dimension in which to compute the finite differences
(0 for x, 1 for y)</p></li>
<li><p><strong>order</strong> (<em>int</em>) – Order of the finite differences (only order 1 and 2 implemented)</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><ul class="simple">
<li><p><strong>i_para_dim has to be 0</strong><strong> (</strong><strong>central finite-difference in x-direction</strong><strong>)</strong> – or 1 (central finite-difference in y-direction)
    Check that the parametric dimension in which to compute the
    finite differences is one that is implemented.</p></li>
<li><p><strong>order has to be 1</strong> – Checks that the order for the finite differences is one
    that is implemented.</p></li>
</ul>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Central finite-differences</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.array</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.central_fd_deg1">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">central_fd_deg1</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">val</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">i_para_dim</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.central_fd_deg1" title="Permalink to this definition"></a></dt>
<dd><p>Computes Central finite differences of order 1</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>val</strong> (<em>np.ndarray</em>) – Input array to compute the central finite-differences on</p></li>
<li><p><strong>i_para_dim</strong> (<em>int</em>) – parametric dimension in which to compute the finite differences
(0 for x, 1 for y)</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>Central finite-differences</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>np.array</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.central_fd_deg2">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">central_fd_deg2</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">val</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">i_para_dim</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.central_fd_deg2" title="Permalink to this definition"></a></dt>
<dd><p>Computes Central finite differences of order 2</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>val</strong> (<em>np.ndarray</em>) – Input array to compute the central finite-differences on</p></li>
<li><p><strong>i_para_dim</strong> (<em>int</em>) – parametric dimension in which to compute the finite differences
(0 for x, 1 for y)</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>Central finite-differences</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>np.array</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.laplace">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">laplace</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">val</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.laplace" title="Permalink to this definition"></a></dt>
<dd><p>Computes Laplace-Operator of a “val””</p>
<p>Used to compute the Laplace-Operator of a Matrix.
Zeros will be returned at the boundary.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>val</strong> (<em>np.array</em>) – Input array to compute the laplace-operator on,
using central finite-differences of order 2</p>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>Laplace-operator</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>np.array</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Grid.jacobi">
<span class="sig-prename descclassname"><span class="pre">Grid.</span></span><span class="sig-name descname"><span class="pre">jacobi</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">val</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">rhs</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">n_iteration</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">int</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">apply_bcs</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">residual</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span><span class="w"> </span><span class="p"><span class="pre">|</span></span><span class="w"> </span><span class="pre">None</span></span><span class="w"> </span><span class="o"><span class="pre">=</span></span><span class="w"> </span><span class="default_value"><span class="pre">None</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Grid.jacobi" title="Permalink to this definition"></a></dt>
<dd><p>Solves the Poisson Equation</p>
<p>∇(∇val) = rhs -&gt; Laplace-Operator einfügen.
Laplace-Operator and rhs are discretised using
central-finite differences.
This discretices equation is transformed to val[i][j].
Then val[i][j] is updated n_itertaion times regarding
the derived formula.
In this context we want to have special boundary-values
after each iteration.
This Jacobi-Iteration is used to solve a pressure-poisson
equation from the incompressible Navier-Stokes so we want
to update the boundaries of thepressure in a specific kind of way.
After each iteration the pressure is updated from the user-written
function apply_bcs.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>val</strong> (<em>np.array</em>) – Value from which one takes the Laplace operator for the lhs.</p></li>
<li><p><strong>rhs</strong> (<em>np.array</em>) – Right-hand-side of the Poisson Equation</p></li>
<li><p><strong>n_iteration</strong> (<em>int</em>) – Number of Jacobi iterations applied.</p></li>
<li><p><strong>apply_bcs</strong> (<em>_type_</em><em>, </em><em>optional</em>) – Function to apply boundary-conditions,
by default None (no update will be applied)</p></li>
<li><p><strong>residual</strong> (<em>float</em><em>, </em><em>None optional</em>) – Decides whether the calculations should be stopped
if the difference in norm in two following time steps
is smaller then the residual (float),
by default None</p></li>
</ul>
</dd>
<dt class="field-even">Returns<span class="colon">:</span></dt>
<dd class="field-even"><p>Solution of the Poisson Equation.</p>
</dd>
<dt class="field-odd">Return type<span class="colon">:</span></dt>
<dd class="field-odd"><p>np.array</p>
</dd>
</dl>
</dd></dl>

</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="tutorial.html" class="btn btn-neutral float-left" title="Tutorial" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="physical_problem.html" class="btn btn-neutral float-right" title="Physical Problem" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Jan Habscheid.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>